<?php
namespace Auction\Entity;

use Doctrine\ORM\Mapping as ORM;



/**
 * Auction auto increment rules.
 *
 * @ORM\Entity
 * @ORM\Table(name="auction_increment")
 */
class Increment
{

	/**
	 * Can archive records.
	 */
	const ARCHIVE = false;
	/**
	 * Pull Synchronization Strategy for this table.
	 */
	const PULL_SYNCH_STRATEGY = false;
	/**
	 * Push Synchronization Strategy for this table.
	 */
	const PUSH_SYNCH_STRATEGY = false;



	/* ------------------------------------ Identification ------------------------------------ */
	/**
	 * @ORM\Id
	 * @ORM\Column(type="integer");
	 * @ORM\GeneratedValue(strategy="AUTO")
	 */
	protected $id;


	/* ------------------------------------ Increment ------------------------------------ */
	/**
	 * @ORM\Column(type="integer", nullable=false, name="range_from", options={"unsigned"=true});
	 */
	protected $from;

	/**
	 * @ORM\Column(type="integer", name="range_to", options={"unsigned"=true});
	 */
	protected $to;

	/**
	 * @ORM\Column(type="decimal", scale=2, precision=11, nullable=false, options={"unsigned"=true});
	 */
	protected $amount = 0.0;



	/**
	 * Magic getter to expose protected properties.
	 *
	 * @param string $property
	 * @return mixed
	 */
	public function __get($property)
	{
		return $this->$property;
	}

	/**
	 * Magic setter to save protected properties.
	 *
	 * @param string $property
	 * @param mixed $value
	 */
	public function __set($property, $value)
	{
		$this->$property = $value;
	}

	/**
	 * Convert the object to an array.
	 * @param array $expand
	 * @param array $intersect
	 * @param boolean $showIdentifiers
	 * @param integer $expandAll
	 * @return array
	 */
	public function toArray(
			array $expand = array(), array $intersect = array(),
			$showIdentifiers = false, $expandAll = 0
			)
	{
		$intersect = array_flip($intersect);
		$includeAll = empty($intersect);
		$data = array();
		($includeAll || isset($intersect['id']))
			&& $data['id'] = $this->id;
		($includeAll || isset($intersect['from']))
			&& $data['from'] = $this->from;
		($includeAll || isset($intersect['to']))
			&& $data['to'] = $this->to;
		($includeAll || isset($intersect['amount']))
			&& $data['amount'] = $this->amount;
		return $data;
	}

	/**
	 * Populate from an array.
	 * @param array $data
	 */
	public function fromArray($data = array())
	{
		isset($data['id'])
			&& $this->id = $data['id'];
		isset($data['from'])
			&& $this->from = $data['from'];
		isset($data['to'])
			&& $this->to = $data['to'];
		isset($data['amount'])
			&& $this->amount = $data['amount'];
	}



}

