<?php
namespace Auction\Entity;

use Doctrine\ORM\Mapping as ORM;



/**
 * @ORM\Entity
 * @ORM\Table(name="auction_open_day_group")
 */
class OpenDayGroup
{

	/**
	 * Can archive records.
	 */
	const ARCHIVE = false;
	/**
	 * Pull Synchronization Strategy for this table.
	 */
	const PULL_SYNCH_STRATEGY = false;
	/**
	 * Push Synchronization Strategy for this table.
	 */
	const PUSH_SYNCH_STRATEGY = false;

	/**
	 * @ORM\Id
	 * @ORM\Column(type="integer");
	 * @ORM\GeneratedValue(strategy="AUTO")
	 */
	protected $id;

	/**
	 * @ORM\ManyToOne(targetEntity="\Auction\Entity\OpenDay")
	 * @ORM\JoinColumn(nullable=false, name="auction_open_day_id")
	 **/
	protected $openDay;

	/**
	 * @ORM\ManyToOne(targetEntity="\Company\Entity\Group")
	 * @ORM\JoinColumn(nullable=false, name="company_group_id")
	 **/
	protected $companyGroup;





	/**
	 * Magic getter to expose protected properties.
	 * @param string $property
	 * @return mixed
	 */
	public function __get($property)
	{
		return $this->$property;
	}

	/**
	 * Magic setter to save protected properties.
	 * @param string $property
	 * @param mixed $value
	 */
	public function __set($property, $value)
	{
		$this->$property = $value;
	}

}
