<?php
namespace Auction\Service;



/**
 * Manage Reply data.
 * @author andre.fourie
 */
class Reply extends \Auction\DataBin\Reply {



	/**
	 * ExecuteAfter: Create.
	 * Send notification.
	 * @param array $meta
	 * @param object|null $jobRecord
	 * @param object|null $record
	 * @param \Workspace\Utility\ServiceInputParams $contract
	 * @return array
	 */
	public function notify($meta, $jobRecord, $record, \Workspace\Utility\ServiceInputParams $contract)
	{
		$record->question->reply = $record;
		$this->em->flush();
		$vehicle = $jobRecord->stock->type->model->make->name
				. ', ' . $jobRecord->stock->type->model->name
				. ', ' . $jobRecord->stock->type->name
				. ' (' . $jobRecord->stock->vehicleYear->name . ')';
		$oNotify = new \Utility\Comms\Notification();
		$oNotify->sendFromTemplate(
				null, null,
				$record->question->company->id, $record->question->profile->id,
				$record->question->profile->email, null,
				null,
				'auction-reply',
				array(
						'first_name' 			=> $record->question->profile->firstName,
						'family_name' 			=> $record->question->profile->familyName,
						'dealer' 				=> $jobRecord->company->name,
						'vehicle' 				=> $vehicle,
						'question' 				=> $record->question->question,
						'reply' 				=> $record->reply
				));
	}


}