<?php
namespace Auction;


/**
 * A workflow.
 * @author andre.fourie
 */

class Workflow extends \Workspace\Workflow
{

	/**
	 * @var string
	 */
	protected $namespace = __NAMESPACE__;
	/**
	 * @var string
	 */
	protected $parentFeature = 'Stock';
	/**
	 * @var string
	 */
	protected $rootEntity = 'Auction';
	/**
	 * @var string
	 */
	protected $rootIdField = 'auction';
	/**
	 * @var string
	 */
	protected $initState = 'Active';
	/**
	 * @var string
	 */
	protected $initTrigger = false;
	/**
	 * @var string
	 */
	protected $primaryEntity = 'Auction';
	/**
	 * @var array
	 */
	protected $entityMap = array(
		'Auction' => '\Auction\Entity\Auction',
		'Stock'   => '\Stock\Entity\Stock',
		'Bid'     => '\Auction\Entity\Bid',
		'AutoBid' => '\Auction\Entity\AutoBid'
	);
	/**
	 * @var array
	 */
	protected $linkMap = array();
	/**
	 * @var array
	 */
	protected $listen = array();
	/**
	 * @var array
	 */
	protected $reclaim = array();
	/**
	 * @var array
	 */
	protected $stateLabel = array();
	/**
	 * @var array
	 */
	protected $stateMap = array(
		'Global'   => array(
			'Actions' => array(
				'Auction.Grid'                    => array(),
				'Auction.HistoricGrid'            => array(),
				'Auction.HistoricMakeSelectList'  => array(),
				'Auction.HistoricModelSelectList' => array(),
				'Auction.HistoricTypeSelectList'  => array(),
				'Auction.HistoricYearSelectList'  => array(),
				'Auction.AdminGrid'               => array(),
				'Basket.Grid'                     => array(),
				'Bid.Create'                      => array(),
				'AutoBid.Create'                  => array(),
				'Increment.List'                  => array(),
				'Increment.Create'                => array(),
				'Increment.Update'                => array(),
				'PublicHoliday.List'              => array(),
				'PublicHoliday.Create'            => array(),
				'PublicHoliday.Update'            => array(),
				'PublicHoliday.Delete'            => array(),
				'OpenDay.List'                    => array(),
				'OpenDay.Create'                  => array(),
				'OpenDay.Update'                  => array(),
				'OpenDay.Delete'                  => array(),
				'Question.AskedGrid'              => array(),
				'Question.ToAnswerGrid'           => array(),
				'Auction.Count'                   => array(),
                'Pdf.PrintPortal'  => array(),
			)
		),
		'Active'   => array(
			'Actions' => array(
				'Auction.View'     => array(),
				'Auction.Remove'   => array(),
				'Pdf.Print'        => array(),
                'Pdf.PrintPortal'  => array(),
				'Basket.Create'    => array(),
				'Basket.SetStatus' => array(),
				'Bid.Grid'         => array(),
				'Bid.Create'       => array(),
				'AutoBid.Create'   => array(),
				'Question.View'    => array(),
				'Question.Create'  => array(),
				'Reply.Create'     => array()
			),
			'Routes'  => array(
				'Workflow.ReturnToStock' => array(
					'Destination' => 'Stock.Handover'
				)
			)
		),
		'Relist'   => array(
			'Actions' => array(
				'Auction.View' => array(),
				'Bid.Grid'     => array(),
				'Pdf.Print'    => array(),
                'Pdf.PrintPortal'  => array(),
			),
			'Routes'  => array(
				'Workflow.Archive' => array(
					'Destination' => 'This.Archived'
				)
			)
		),
		'Undone'   => array(
			'Actions' => array(
				'Auction.View' => array(),
				'Bid.Grid'     => array(),
				'Pdf.Print'    => array(),
                'Pdf.PrintPortal'  => array(),
			),
			'Routes'  => array(
				'Workflow.Archive' => array(
					'Destination' => 'This.Archived'
				)
			)
		),
		'Sold'     => array(
			'Actions' => array(
				'Auction.View' => array(),
				'Auction.Undo' => array(),
				'Bid.Grid'     => array(),
				'Pdf.Print'    => array(),
                'Pdf.PrintPortal'  => array(),
			),
			'Routes'  => array(
				'Workflow.Archive' => array(
					'Destination' => 'This.Archived'
				)
			)
		),
		'Archived' => array(
			'Actions' => array(
				'Auction.View' => array(),
				'Bid.Grid'     => array(),
				'Pdf.Print'    => array(),
                'Pdf.PrintPortal'  => array(),
				'AutoBid.Create'   => array(),
                'Bid.Create'   => array(),
			)
		)
	);


}
