<?php
namespace Company\DataBin;



/**
 * Manage Company data.
 * @author andre.fourie
 */
class GroupDivision extends \Workspace\Service\DataBin
{

	/**
	 * @var array
	 */
	protected $meta = array(
			'Base'        => 'GroupDivision',
			'DatasetName' => 'divisions',
			'Entity'      => '\Company\Entity\GroupDivision',
			'References'  => array(
					'group'          => '\Company\Entity\Group'
			),
			'Dependants'  => array()
	);
	/**
	 * @var array
	*/
	protected $metaSelectList = array(
			'Type'          => 'SelectList',
			'Contract'      => 'Recurring',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Filter' => array(
							'group' => 'Id',
                            'id' => 'Id'
					)
			),
			'Filter'   => array(),
			'Label'    => array(
				'Format' => '[name]',
				'Fields' => array('name')
			)
	);
	/**
	 * @var array
	*/
	protected $metaList = array(
			'Type'			=> 'List',
			'Contract'      => 'Recurring',
			'Expand' 		=> array('group'),
			'RequiredInput' => array(),
			'OptionalInput' => array(),
			'Filter' 		=> array(),
			'OrderBy' 		=> array(
					'name' => 'ASC'
			),
			'Fields' => array()
	);
	/**
	 * @var array
	*/
	protected $metaCreate = array(
			'Type'			=> 'Create',
			'Contract' 		=> 'Recurring',
			'RequiredInput' => array(
					'GroupDivision' => array(
							'group' 		=> 'Id',
							'name' 			=> 'String100'
					)
			),
			'OptionalInput' => array()
	);
	/**
	 * @var array
	*/
	protected $metaUpdate = array(
			'Type'			=> 'Update',
			'Contract' 		=> 'UseOnce',
			'RequiredInput' => array(
					'GroupDivision' => array(
							'group' 		=> 'Id',
							'name' 			=> 'String100'
					)
			),
			'OptionalInput' => array()
	);

}