<?php
namespace Newsletter\DataBin;



/**
 * Manage Newsletter data.
 * @author andre.fourie
 */
class Newsletter extends \Workspace\Service\DataBin
{

	/**
	 * @var array
	 */
	protected $meta = array(
	    'Base'        => 'Newsletter',
	    'DatasetName' => 'newsletters',
	    'Entity'      => '\Newsletter\Entity\Newsletter',
	    'References'  => array(
	        'attachment' => '\Utility\Entity\Attachment'
	    ),
	    'Dependants'  => array()
	);
	/**
	 * @var array
	*/
	protected $metaGrid = array(
	    'Type'          => 'Grid',
	    'Contract'      => 'Recurring',
	    'RequiredInput' => array(),
	    'OptionalInput' => array(
	        'Grid'  => array(
	            'NumberOfRecords' => 'Integer',
	            'Page'            => 'Integer',
	            'Filter'          => 'Array',
	            'OrderBy'         => 'Array'
	        )
	    ),
	    'Base'            => 'newsletter',
	    'NumberOfRecords' => 10,
        'Query'           => 'SELECT [SELECTION]
				              FROM \Newsletter\Entity\Newsletter newsletter
							  LEFT JOIN newsletter.attachment attachment
				              [WHERE] [ORDER]',
	    'Selection'       => 'newsletter, attachment',
	    'Filter'          => array(),
	    'OrderBy'         => array('newsletter.created' => 'DESC'),
	    'Fields'          => array(
				                'id',
				                'subject',
				                'created' => 'DateTime',
				                'updated' => 'DateTime',
				                'sentTo',
				                'jobState',
				                'attachment' => array(
				                    'id',
				                    'filename'
				                )
				            )
	);
	/**
	 * @var array
	 */
	protected $metaView = array(
	    'Type'        => 'Update',
	    'Contract'    => 'Recurring',
	    'Expand'      => array(
	    				'attachment'
	    ),
	    'RequiredInput' => array(),
	    'OptionalInput' => array()
	);
	/**
	 * @var array
	*/
	protected $metaCreate = array(
			'Type'			=> 'Create',
			'Contract' 		=> 'Recurring',
			'Options'       => array(
					'Boolean' => array(
							'SaveDraft' => false,
							'TestDraft' => false,
							'Send' 		=> false
					)
			),
			'ExecuteAfter'  => array(
					'sendNewsletter'
			),
			'RequiredInput' => array(
					'Newsletter' => array(
							'subject'     	=> 'String100',
							'content' 		=> 'LongText'
					)
			),
			'OptionalInput' => array(
					'Newsletter' => array(
							'attachment' 	=> 'Id'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaUpdate = array(
			'Type'			=> 'Update',
			'Contract' 		=> 'UseOnce',
			'Options'       => array(
					'Boolean' => array(
							'SaveDraft' => false,
							'TestDraft' => false,
							'Send' 		=> false
					)
			),
			'ExecuteAfter'  => array(
					'sendNewsletter'
			),
			'RequiredInput' => array(
					'Newsletter' => array(
							'subject'     	=> 'String100',
							'content' 		=> 'LongText'
					)
			),
			'OptionalInput' => array(
					'Newsletter' => array(
							'attachment' 	=> 'Id'
					)
			)
	);


}
