<?php
namespace Newsletter;



/**
 * A workflow.
 * @author andre.fourie
 */
class Workflow extends \Workspace\Workflow
{

	/**
	 * @var string
	 */
	protected $namespace = __NAMESPACE__;
	/**
	 * @var string
	 */
	protected $parentFeature = 'Utility';
	/**
	 * @var string
	 */
	protected $rootEntity    = 'Newsletter';
	/**
	 * @var string
	 */
	protected $rootIdField   = 'newsletter';
	/**
	 * @var string
	 */
	protected $initState     = 'Active';
	/**
	 * @var string
	 */
	protected $initTrigger   = false;
	/**
	 * @var string
	 */
	protected $primaryEntity = 'Newsletter';
	/**
	 * @var array
	 */
	protected $entityMap = array(
			'Newsletter' 		=> '\Newsletter\Entity\Newsletter',
			'Attachment' 		=> '\Utility\Entity\Attachment'
	);
	/**
	 * @var array
	 */
	protected $linkMap = array();
	/**
	 * @var array
	 */
	protected $listen = array();
	/**
	 * @var array
	 */
	protected $reclaim = array();
	/**
	 * @var array
	 */
	protected $stateLabel = array();
	/**
	 * @var array
	 */
	protected $stateMap = array(
			'Global' => array(
				'Actions' => array(
					'Newsletter.Grid'           	=> array(),
					'Newsletter.Create' 			=> array()
				)
			),
			'Draft' => array(
				'Actions' => array(
					'Newsletter.View' 				=> array(),
					'Newsletter.Update' 			=> array()
				),
				'Routes' => array(
					'Workflow.Archive'    => array(
							'Destination' => 'This.Archived'
					)
				)
			),
			'Sending' => array(
				'Actions' => array(
					'Newsletter.View' 				=> array(),
					'Newsletter.Update' 			=> array()
				)
			),
			'Sent' => array(
				'Actions' => array(
					'Newsletter.View' 				=> array(),
					'Newsletter.Update' 			=> array()
				),
				'Routes' => array(
					'Workflow.Archive'    => array(
							'Destination' => 'This.Archived'
					)
				)
			),
			'Archived' => array(
				'Actions' => array(
					'Newsletter.Update' 			=> array()
				)
			)
	);


}
