<?php
namespace PriceGuide\Entity;

use Doctrine\ORM\Mapping as ORM;



/**
 * @ORM\Entity
 * @ORM\Table(name="price_guide_club_member_make")
 */
class MemberMake
{

	/**
	 * Can archive records.
	 */
	const ARCHIVE = false;
	/**
	 * Pull Synchronization Strategy for this table.
	 */
	const PULL_SYNCH_STRATEGY = false;
	/**
	 * Push Synchronization Strategy for this table.
	 */
	const PUSH_SYNCH_STRATEGY = false;


	/**
	 * @ORM\Id
	 * @ORM\Column(type="integer");
	 * @ORM\GeneratedValue(strategy="AUTO")
	 */
	protected $id;

	/**
	 * @ORM\ManyToOne(targetEntity="Member", inversedBy="makes")
	 * @ORM\JoinColumn(name="price_guide_club_member_id", referencedColumnName="id")
	 **/
	protected $member;

	/**
	 * @ORM\ManyToOne(targetEntity="\Stock\Entity\Make")
	 * @ORM\JoinColumn(name="vehicle_make_id", referencedColumnName="id")
	 **/
	protected $make;



	/**
	 * Magic getter to expose protected properties.
	 * @param string $property
	 * @return mixed
	 */
	public function __get($property)
	{
		return $this->$property;
	}

	/**
	 * Magic setter to save protected properties.
	 * @param string $property
	 * @param mixed $value
	 */
	public function __set($property, $value)
	{
		$this->$property = $value;
	}

	/**
	 * Convert the object to an array.
	 * @param array $expand
	 * @param array $intersect
	 * @return array
	 */
	public function toArray(array $expand = array(), array $intersect = array())
	{
		$includeAll = empty($intersect);
		$data = array();
		($includeAll || isset($intersect['id']))
			&& $data['id'] = $this->id;
		($includeAll || isset($intersect['make']))
			&& $data['make'] = $this->make->toArray($expand, $intersect);
		($includeAll || isset($intersect['member']))
			&& $data['member'] = $this->member->toArray($expand, $intersect);
		return $data;
	}

	/**
	 * Populate from an array.
	 * @param array $data
	 */
	public function fromArray($data = array())
	{
		isset($data['id'])
			&& $this->id = $data['id'];
		isset($data['make'])
			&& $this->make  = $data['make'];
		isset($data['member'])
			&& $this->member  = $data['member'];
	}

}
