<?php
namespace PriceGuide\Service;



/**
 * Manage Member data.
 * @author andre.fourie
 */
class Invite extends \PriceGuide\DataBin\Invite
{



	/**
	 * ExecuteAfter: Update.
	 * Apply filtering to all clubs if option is selected.
	 *
	 * @param array $meta
	 * @param object|null $jobRecord
	 * @param object|null $record
	 * @param \Workspace\Utility\ServiceInputParams $contract
	 * @return array
	 */
	public function applyFilterToAll($meta, $jobRecord, $record, \Workspace\Utility\ServiceInputParams $contract)
	{
		#-> Change status.
		\Utility\Debug::errorLog('applyFilterToAll', $contract->options->ApplyToAll);
	}

	/**
	 * ExecuteAfter: Decline.
	 * Set status to Archived.
	 *
	 * @param array $meta
	 * @param object|null $jobRecord
	 * @param object|null $record
	 * @param \Workspace\Utility\ServiceInputParams $contract
	 * @return array
	 */
	public function archiveMember($meta, $jobRecord, $record, \Workspace\Utility\ServiceInputParams $contract)
	{
		#-> Change status.
		$record->status = 'Archived';
		$this->em->flush();
	}



}