<?php
namespace Report\DataBin;



/**
 * Report reports.
 * @author andre.fourie
 */
class Report extends \Workspace\Service\DataBin
{

	/**
	 * @var array
	 */
	protected $meta = array(
			'Base'        => 'Report',
			'DatasetName' => '',
			'Entity'      => '',
			'References'  => array(),
			'Dependants'  => array()
	);
	/**
	 * @var array
	*/
	protected $metaSms = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Sms',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'clickVal'      => 'String10',
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaEmail = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Email',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10',
							'profile'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaAuction = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Auction',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);

    /**
     * @var array
     */
    protected $metaStockAuction = array(
        'Type'          => 'Report',
        'Builder'       => '\Report\Report\StockAuction',
        'Writer'        => '\Utility\Export\ExcelReport',
        'Output'        => 'Download',
        'RequiredInput' => array(),
        'OptionalInput' => array(
            'Report' => array(
                'dateFrom'      => 'String10',
                'dateTo'        => 'String10',
                'group'         => 'String10',
                'groupDivision' => 'String10',
                'company'       => 'String10'
            )
        )
    );
	/**
	 * @var array
	*/
	protected $metaTuhpiLog = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\TuhpiLog',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
    /**
     * @var array
     */
    protected $metaTuhpiAccidentLog = array(
        'Type'          => 'Report',
        'Builder'       => '\Report\Report\TuhpiAccidentLog',
        'Writer'        => '\Utility\Export\ExcelReport',
        'Output'        => 'Download',
        'RequiredInput' => array(),
        'OptionalInput' => array(
            'Report' => array(
                'dateFrom'      => 'String10',
                'dateTo'        => 'String10',
                'group'         => 'String10',
                'groupDivision' => 'String10',
                'company'       => 'String10'
            )
        )
    );
	/**
	 * @var array
	*/
	protected $metaPriceGuide = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\PriceGuide',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaPriceGuideStatistical = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\PriceGuideStatistical',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaTrader = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Trader',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
  /**
	 * @var array
	*/
	protected $metaAuctionTrader = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\AuctionTrader',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaAuctionAdherence = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\AuctionAdherence',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaNoMatch = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\NoMatch',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaPriceGuideFlash = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\PriceGuideFlash',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaInvoice = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Invoice',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'clickVal'      => 'String10',
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaLoadVsSold = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\LoadVsSold',
			'Writer'        => '\Report\Report\LoadVsSoldExcel',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'year'      => 'String10',
              'region'         => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
              'regionalManager' => 'Array',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaLoadVsSoldDetail = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\LoadVsSoldDetail',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaAdherence = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Adherence',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10',
							'region'        => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaLogin = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Login',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'days'      	=> 'Integer',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaValuation = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\Valuation',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaAdminValuation = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\AdminValuation',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);
	/**
	 * @var array
	 */
	protected $metaValuationStatistical = array(
			'Type'          => 'Report',
			'Builder'       => '\Report\Report\ValuationStatistical',
			'Writer'        => '\Utility\Export\ExcelReport',
			'Output'        => 'Download',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Report' => array(
							'dateFrom'      => 'String10',
							'dateTo'        => 'String10',
							'group'         => 'String10',
							'groupDivision' => 'String10',
							'company'       => 'String10'
					)
			)
	);

}