<?php
namespace Statistical\Entity;

use Doctrine\ORM\Mapping as ORM;



/**
 * Click tracking for banner adverts.
 * @ORM\Entity
 * @ORM\Table(name="lib_click")
 */
class Click
{

	/**
	 * Can not archive records.
	 */
	const ARCHIVE = false;
	/**
	 * Pull Synchronization Strategy for this table.
	 */
	const PULL_SYNCH_STRATEGY = false;
	/**
	 * Push Synchronization Strategy for this table.
	 */
	const PUSH_SYNCH_STRATEGY = false;


	/**
	 * @ORM\Id
	 * @ORM\Column(type="integer");
	 * @ORM\GeneratedValue(strategy="AUTO")
	 */
	protected $id;

	/**
	 * @ORM\Column(type="string", nullable=true, length=100, name="banner_id")
	 */
	protected $bannerId;

	/**
	 * @ORM\Column(type="string", nullable=true, length=100, name="ip_address")
	 */
	protected $ipAddress;

	/**
	 * @ORM\Column(type="datetime");
	 */
	protected $created;



	/**
	 * Magic getter to expose protected properties.
	 * @param string $property
	 * @return mixed
	 */
	public function __get($property)
	{
		return $this->$property;
	}

	/**
	 * Magic setter to save protected properties.
	 * @param string $property
	 * @param mixed $value
	 */
	public function __set($property, $value)
	{
		$this->$property = $value;
	}
		
	
	/**
	 * @ORM\PrePersist
	 */
	public function setCreateTime()
	{
		$this->created = new \DateTime("now");
	}
	/**
	 * Convert the object to an array.
	 * @param array $expand
	 * @param array $intersect
	 * @return array
	 */
	public function toArray(array $expand = array(), array $intersect = array())
	{
		$includeAll = empty($intersect);
		$data = array();
		($includeAll || isset($intersect['id']))
			&& $data['id'] = $this->id;
		($includeAll || isset($intersect['ipAddress']))
			&& $data['ipAddress'] = $this->ipAddress;
		($includeAll || isset($intersect['bannerId']))
			&& $data['bannerId'] = $this->bannerId;
		($includeAll || isset($intersect['created']))
			&& $data['created'] = $this->created;
		return $data;
	}

	/**
	 * Populate from an array.
	 * @param array $data
	 */
	public function fromArray($data = array())
	{
		isset($data['id'])
			&& $this->id = $data['id'];
		isset($data['ipAddress'])
		&& $this->ipAddress = $data['ipAddress'];
		isset($data['bannerId'])
		&& $this->ipAddress = $data['bannerId'];
		isset($data['created'])
			&& $this->created  = $data['created'];
	}

}
