<?php
namespace Stock\DataBin;



/**
 * Manage Condition data.
 * @author andre.fourie
 */
class Condition extends \Workspace\Service\DataBin
{

	/**
	 * @var array
	 */
	protected $meta = array(
			'Base'        => 'Condition',
			'DatasetName' => 'condition',
			'Entity'      => '\Stock\Entity\Condition',
			'References'  => array(),
			'Dependants'  => array()
	);
	/**
	 * @var array
	*/
	protected $metaList = array(
			'Contract'      => 'Recurring',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Filter' => array(
							'name' => 'String75'
					)
			),
			'Filter' => array(),
			'Fields' => array(
				'name'
			),
			'Expand' => array()
	);
	/**
	 * @var array
	*/
	protected $metaSelectList = array(
			'Type'          => 'SelectList',
			'Contract'      => 'Recurring',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Filter' => array(
							'name' => 'String75'
					)
			),
			'Filter'   => array(),
			'Label'    => array(
				'Format' => '[name]',
				'Fields' => array('name')
			)
	);
	/**
	 * @var array
	*/
	protected $metaCreate = array(
			'Contract' => 'Recurring',
			'RequiredInput' => array(
					'Condition' => array(
							'name' => 'String75'
					)
			),
			'OptionalInput' => array()
	);
	/**
	 * @var array
	*/
	protected $metaUpdate = array(
			'Contract' => 'UseOnce',
			'RequiredInput' => array(
					'Condition' => array(
							'name' => 'String75'
					)
			),
			'OptionalInput' => array()
	);
	/**
	 * @var array
	*/
	protected $metaDelete = array(
			'Contract' => 'UseOnce'
	);

}