<?php
namespace Stock\DataBin;

/**
 * Manage Pricing History data.
 * @author Andre.b
 */
class PricingHistory extends \Workspace\Service\DataBin
{

	/**
	 * @var array
	 */
	protected $meta = array(
			'Base'        => 'PricingHistory',
			'DatasetName' => 'pricinghistory',
			'Entity'      => '\Stock\Entity\PricingHistory',
			'References'  => array(),
			'Dependants'  => array()
	);
	/**
	 * @var array
	*/
	protected $metaGrid = array(
	    'Type'          => 'Grid',
		'Export'        => false,
	    'Contract'      => 'Recurring',
		'Options'       => array(),
	    'RequiredInput' => array(),
	    'OptionalInput' => array(
	        'Grid'  => array(
	            'NumberOfRecords' => 'Integer',
				'Filter'          => 'Array'
	         )
	    ),
		'Base'            => 'PricingHistory',
	    'NumberOfRecords' => 10,
        'Query'           => 'SELECT [SELECTION]
				              FROM \Stock\Entity\PricingHistory PricingHistory
							  [WHERE] [ORDER]',
	    'Selection'       => 'PricingHistory',
		'Filter'          => array(),
	    'OrderBy'         => array('PricingHistory.date' => 'DESC'),
	    'Fields'          => array(
	    						'id',
	    					    'date' => 'DateTime',
			                	'trade',
			                	'totalRecon',
			                    'km',
					            'pricegOffer',
					            'auctionWinningBid',
	    						'stockId'
	    		)
	);
}