<?php
namespace Stock\DataBin;



/**
 * Manage Type data.
 * @author andre.fourie
 */
class Type extends \Workspace\Service\DataBin
{

	/**
	 * @var array
	 */
	protected $meta = array(
			'Base'        => 'Type',
			'DatasetName' => 'types',
			'Entity'      => '\Stock\Entity\Type',
			'References'  => array(
					'model'    => '\Stock\Entity\Model',
					'category' => '\Stock\Entity\Category'
			),
			'Dependants'  => array()
	);
	/**
	 * @var array
	*/
	protected $metaList = array(
			'Contract'      => 'Recurring',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Filter' => array(
							'name'       => 'String75',
							'mmCode'     => 'Digit10',
							'introYear'  => 'Digit4',
							'introMonth' => 'MonthDigit',
							'discYear'   => 'Digit4',
							'discMonth'  => 'MonthDigit'
					)
			),
			'Filter' => array(),
			'Fields' => array(
				'name',      'mmCode',
				'introYear', 'introMonth',
				'discYear',  'discMonth'
			),
			'Expand' => array()
	);
	/**
	 * @var array
	*/
	protected $metaSelectList = array(
			'Type'          => 'SelectList',
			'Contract'      => 'Recurring',
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Filter' => array(
							'name'       => 'String75',
							'mmCode'     => 'Digit10',
							'introYear'  => 'Digit4',
							'introMonth' => 'MonthDigit',
							'discYear'   => 'Digit4',
							'discMonth'  => 'MonthDigit'
					)
			),
			'Filter'   => array(),
			'Label'    => array(
				'Format' => '[name] ([introYear] - [discYear])',
				'Fields' => array('name', 'introYear', 'discYear' => 'Current')
			)
	);
	/**
	 * @var array
	*/
	protected $metaGetMmCode = array(
			'Type'          => 'View',
			'Contract' 		=> 'Recurring',
			'RequiredInput' => array(),
			'OptionalInput' => array()
	);
	/**
	 * @var array
	*/
	protected $metaCreate = array(
			'Contract' => 'Recurring',
			'RequiredInput' => array(
					'Type' => array(
							'name'       => 'String75',
							'mmCode'     => 'Digit10',
							'introYear'  => 'Digit4',
							'introMonth' => 'MonthDigit'
					)
			),
			'OptionalInput' => array(
					'Type' => array(
							'discYear'   => 'Digit4',
							'discMonth'  => 'MonthDigit'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaUpdate = array(
			'Contract' => 'UseOnce',
			'RequiredInput' => array(
					'Type' => array(
							'name'       => 'String75',
							'mmCode'     => 'Digit10',
							'introYear'  => 'Digit4',
							'introMonth' => 'MonthDigit'
					)
			),
			'OptionalInput' => array(
					'Type' => array(
							'discYear'   => 'Digit4',
							'discMonth'  => 'MonthDigit'
					)
			)
	);
	/**
	 * @var array
	*/
	protected $metaDelete = array(
			'Contract' => 'UseOnce'
	);

}