<?php
namespace Utility\Comms;


/**
 * Facilitates chatting to android devices via GCM.
 * @author andre.fourie
 */
class Gcm
{


	/**
	 * Send message via GCM.
	 * @param string|array $registrationIds
	 * @param array        $messageData
	 * @param array        $collapse
	 * @return array
	 */
	static public function send($registrationIds, array $messageData, array $collapse = array())
	{
		//-- Preparation work.
		if (!is_array($registrationIds))
		{
			$registrationIds = array($registrationIds);
		}
		if (0 == count($registrationIds))
		{
			return array(
				'Success' => 0,
				'Failed'  => 0
			);
		}

		//-- GCM client.
		$client = new \ZendService\Google\Gcm\Client();
		$client->setApiKey('AIzaSyCrg16ZpPKm0QU2NhhCanH0O-MaxwoO8LU');
		$httpClient = new \Zend\Http\Client(null, array(
			'adapter'       => 'Zend\Http\Client\Adapter\Socket',
			'sslverifypeer' => false
		));
		$client->setHttpClient($httpClient);

		//-- GCM message.
		$message = new \ZendService\Google\Gcm\Message();
		$message->setRegistrationIds($registrationIds);
		$message->setData($messageData);
		foreach ($collapse as $collapseKey)
		{
			$message->setCollapseKey($collapseKey);
		}
		$message->setRestrictedPackageName('com.nirph.bid4cars');
		$message->setDelayWhileIdle(false);
		$message->setTimeToLive(600);
		$message->setDryRun(false);

		//-- Send the message.
		try
		{
			$response = $client->send($message);
		}
		catch (\Exception $e)
		{
			\Utility\Debug::errorLog(__METHOD__ . ':ERROR', $e->getMessage());
			return array(
				'Success' => 0,
				'Failed'  => count($registrationIds)
			);
		}
		return array(
			'Success' => $response->getSuccessCount(),
			'Failed'  => $response->getFailureCount()
		);
	}


}

