<?php

namespace UVd\DoctrineFunction;

use Doctrine\ORM\Query\Lexer;
use Doctrine\ORM\Query\AST\Functions\FunctionNode;

/**
 * SOUNDEX
 *
 * Allows Doctrine 2.0 Query Language to execute a MySQL SOUNDEX function
 * You must boostrap this function in your ORM as a DQLFunction.
 *
 */
class Soundex extends FunctionNode
{
	public $stringExpression = null;
	public function parse(\Doctrine\ORM\Query\Parser $parser)
	{
		$parser->match(Lexer::T_IDENTIFIER);
		$parser->match(Lexer::T_OPEN_PARENTHESIS);
		$this->stringExpression = $parser->StringPrimary();
		$parser->match(Lexer::T_CLOSE_PARENTHESIS);
	}
	public function getSql(\Doctrine\ORM\Query\SqlWalker $sqlWalker)
	{
		return 'SOUNDEX(' .
				$this->stringExpression->dispatch($sqlWalker) .
				')';
	}
}