<?php
namespace Utility\Entity;

use Doctrine\ORM\Mapping as ORM;



/**
 * A notification template.
 * @ORM\Entity
 * @ORM\Table(name="lib_repeater_template")
 */
class RepeaterTemplate
{

	/**
	 * Can archive records.
	 */
	const ARCHIVE = false;
	/**
	 * Pull Synchronization Strategy for this table.
	 */
	const PULL_SYNCH_STRATEGY = false;
	/**
	 * Push Synchronization Strategy for this table.
	 */
	const PUSH_SYNCH_STRATEGY = false;

	/**
	 * @ORM\Id
	 * @ORM\Column(type="integer");
	 * @ORM\GeneratedValue(strategy="AUTO")
	 */
	protected $id;

	/**
	 * @ORM\Column(type="string", length=50, name="group_field")
	 */
	protected $groupField;

	/**
	 * @ORM\Column(type="text", name="group_repeater")
	 */
	protected $groupRepeater;

	/**
	 * @ORM\Column(type="text", name="row_repeater_odd")
	 */
	protected $rowRepeaterOdd;

	/**
	 * @ORM\Column(type="text", name="row_repeater_even")
	 */
	protected $rowRepeaterEven;


	/**
	 * Magic getter to expose protected properties.
	 * @param string $property
	 * @return mixed
	 */
	public function __get($property)
	{
		return $this->$property;
	}

	/**
	 * Magic setter to save protected properties.
	 * @param string $property
	 * @param mixed $value
	 */
	public function __set($property, $value)
	{
		$this->$property = $value;
	}

	/**
	 * Convert the object to an array.
	 * @param array $expand
	 * @return array
	 */
	public function toArray(array $expand = array())
	{
		return array(
				'id'              => $this->id,
				'groupField'      => $this->groupField,
				'groupRepeater'   => $this->groupRepeater,
				'rowRepeaterOdd'  => $this->rowRepeaterOdd,
				'rowRepeaterEven' => $this->rowRepeaterEven
		);
	}

	/**
	 * Populate from an array.
	 * @param array $data
	 */
	public function fromArray($data = array())
	{
		isset($data['id'])
			&& $this->id = $data['id'];
		isset($data['groupField'])
			&& $this->groupField  = $data['groupField'];
		isset($data['groupRepeater'])
			&& $this->groupRepeater  = $data['groupRepeater'];
		isset($data['rowRepeaterOdd'])
			&& $this->rowRepeaterOdd  = $data['rowRepeaterOdd'];
		isset($data['rowRepeaterEven'])
			&& $this->rowRepeaterEven  = $data['rowRepeaterEven'];
	}

}
