<?php

namespace Valuation\DataBin;

/**
 * Manage Valuation Deal Not Done.
 * @author gerard.brown
 */
class DealNotDoneSelection extends \Workspace\Service\DataBin
{

  /**
   * @var array
   */
  protected $meta = array(
    'Base' => 'DealNotDoneSelection',
    'DatasetName' => 'DealNotDoneSelection',
    'Entity' => '\Valuation\Entity\DealNotDoneSelection',
    'References' => array(),
    'Dependants' => array()
  );

  /**
   * @var array
   */
  protected $metaList = array(
    'Contract' => 'Recurring',
    'RequireAuth' => true,
    'RequiredInput' => array(),
    'OptionalInput' => array(
      'Filter' => array(
        'name' => 'String20'
      )
    ),
    'Filter' => array(),
    'Fields' => array(
      'name'
    ),
    'Expand' => array()
  );


    /**
     * @var array
     */
    protected $metaSelectList = array(
        'Type'	  => 'SelectList',
        'Contract'      => 'Recurring',
        'RequiredInput' => array(),
        'OptionalInput' => array(
            'Filter' => array(
                'name'           => 'String20'
            )
        ),
        'Filter'   => array(),
        'Label'    => array(
            'Format' => '[name]',
            'Fields' => array('name')
        )
    );


  /**
   * @var array
   */
  protected $metaCreate = array(
    'Type' => 'Create',
    'Contract' => 'Recurring',
    'Flags' => array(),
    'RelatedEntityFromInput' => array(),
    'RequiredInput' => array(
      'DealNotDoneSelection' => array(
        'name' => 'String20'
      ),
    ),
    'OptionalInput' => array(
      'DealNotDoneSelection' => array()
    )
  );



  /**
   * @var array
   */
  protected $metaUpdate = array(
    'Type' => 'Update',
    'Contract' => 'UseOnce',
    'RequireAuth' => true,
      'RelatedEntityFromInput' => array(),
      'RequiredInput' => array(
          'DealNotDoneSelection' => array(
              'name' => 'String20'
          ),
      ),
      'OptionalInput' => array(
          'DealNotDoneSelection' => array()
      )
  );


  /**
   * @var array
   */
  protected $metaDelete = array(
    'Contract' => 'UseOnce',
    'RequireAuth' => true
  );



  /**
   * Dynamic filtering.
   */
  public function __construct()
  {

  }

}
