<?php

namespace Valuation\DataBin;

/**
 * Manage Valuation Time Slots data.
 * @author andre.fourie
 */
class ValuationTimeSlots extends \Workspace\Service\DataBin
{

  /**
   * @var array
   */
  protected $meta = array(
    'Base' => 'ValuationTimeSlots',
    'DatasetName' => 'valuationTimeSlots',
    'Entity' => '\Valuation\Entity\ValuationTimeSlots',
    'References' => array(),
    'Dependants' => array()
  );

  /**
   * @var array
   */
  protected $metaList = array(
    'Contract' => 'Recurring',
    'RequireAuth' => true,
    'RequiredInput' => array(),
    'OptionalInput' => array(
      'Filter' => array(
        'created' => 'Date',
        'updated' => 'Date',
        'timeSlot' => 'String20',
        'timeSlotDisplayName' => 'String20',
      )
    ),
    'Filter' => array(),
    'Fields' => array(
      'timeSlot',
      'timeSlotDisplayName'
    ),
    'Expand' => array()
  );


    /**
     * @var array
     */
    protected $metaSelectList = array(
        'Type'	  => 'SelectList',
        'Contract'      => 'Recurring',
        'RequiredInput' => array(),
        'OptionalInput' => array(
            'Filter' => array(
                'timeSlot'           => 'String20'
            )
        ),
        'Filter'   => array(),
        'Label'    => array(
            'Format' => '[timeSlot]',
            'Fields' => array('timeSlot')
        )
    );


  /**
   * @var array
   */
  protected $metaCreate = array(
    'Type' => 'Create',
    'Contract' => 'Recurring',
    'Flags' => array(),
    'RelatedEntityFromInput' => array(),
    'RequiredInput' => array(
      'ValuationTimeSlots' => array(
        'timeSlot' => 'String20',
        'timeSlotDisplayName' => 'String20'
      ),
    ),
    'OptionalInput' => array(
      'ValuationTimeSlots' => array()
    )
  );



  /**
   * @var array
   */
  protected $metaUpdate = array(
    'Type' => 'Update',
    'Contract' => 'UseOnce',
    'RequireAuth' => true,
      'RelatedEntityFromInput' => array(),
      'RequiredInput' => array(
          'ValuationTimeSlots' => array(
              'timeSlot' => 'String20',
              'timeSlotDisplayName' => 'String20'
          ),
      ),
      'OptionalInput' => array(
          'ValuationTimeSlots' => array()
      )
  );


  /**
   * @var array
   */
  protected $metaDelete = array(
    'Contract' => 'UseOnce',
    'RequireAuth' => true
  );



  /**
   * Dynamic filtering.
   */
  public function __construct()
  {

  }

}
