<?php
namespace Valuation\DataBin;



/**
 * Manage XmlRpc request logs.
 * @author andre.fourie
 */
class XmlRpcRequestLog extends \Workspace\Service\DataBin
{

	/**
	 * @var array
	 */
	protected $meta = array(
			'Base'        => 'XmlRpcRequestLog',
			'DatasetName' => '',
			'Entity'      => '\Valuation\Entity\XmlRpcRequestLog',
			'References'  => array(
					'xmlRpcClient' 	=> '\Valuation\Entity\XmlRpc',
					'valuation' 	=> '\Valuation\Entity\Valuation',
			),
			'Dependants'  => array()
	);
	/**
	 * @var array
	*/
	protected $metaGrid = array(
			'Type'          => 'Grid',
			'Contract'      => 'Recurring',
			'Options'       => array(),
			'RequiredInput' => array(),
			'OptionalInput' => array(
					'Grid' => array(
							'NumberOfRecords' => 'Integer',
							'Page'            => 'Integer',
							'Filter'          => 'Array',
							'OrderBy'         => 'Array',
					)
			),
			'Base'            => 'xmlRpcRequestLog',
			'NumberOfRecords' => 10,
			'Query'           => 'SELECT [SELECTION]
								FROM \Valuation\Entity\XmlRpcRequestLog xmlRpcRequestLog
								LEFT JOIN xmlRpcRequestLog.xmlRpcClient xmlRpcClient
								LEFT JOIN xmlRpcRequestLog.valuation valuation
								[WHERE] [ORDER]',
			'Selection'       => 'xmlRpcRequestLog, xmlRpcClient, valuation',
			'Filter'          => array(),
			'OrderBy'         => array('xmlRpcRequestLog.created' => 'DESC'),
			'Fields'          => array(
									'id',
									'xmlRpcClient' => array(
										'id',
										'clientName',
									),
									'valuation' => array(
										'id',
										'valuationNumber',
									),
									'clientApiId',
									'ipAddress',
									'methodName',
									'status',
									'created' => 'DateTime',
									'packet' => 'Array'
								)
	);



}